#version 150
precision highp float;

#moj_import <fog.glsl>

uniform sampler2D Sampler0;
uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec3 xyzPos;

out vec4 fragColor;

vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;

void main() {
    if (color.a < 0.1) {
        discard;
    }

    if(color.r <= 126.50/255.0 && color.r > 126.49/255.0 && color.g == 252/255.0 && color.b <= 31.63/255.0 && color.b > 31.62/255.0){
        color = vec4(0.451, 0.773, 0.969, color.a);
    }
	
    if(color.r <= 31.63/255.0 && color.r > 31.62/255.0 && color.g <= 62.26/255.0 && color.g > 62.25/255.0 && color.b <= 7.91/255.0 && color.b > 7.90/255.0){
        color = vec4(0.098, 0.216, 0.353, color.a);
    }

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
